# pycpu.py - Interface library to pycpu C library
import os
import sys
from ctypes import *

# Load the library
_dll = windll.LoadLibrary("pycpu.dll")

class cpu_info(Structure):
    pass
    
cpu_info._fields_ = [
    ("vendor_id", c_char * 13),
    ("max_cpuid", c_uint),
    ("max_ext_cpuid", c_uint),
    ("amd_flags", c_uint),
    ("amd_flags2", c_uint),
    ("model_name", c_char_p),
    ("processor_name", c_char * 49),
    ("family", c_uint),
    ("model", c_uint),
    ("stepping", c_uint),
    ("clock_mhz", c_double),
    ("clock_ghz", c_double)
]
# end cpu_info

class cpu_cap(Structure):
    pass

cpu_cap._fields_ = [
    ("id", c_int),
    ("bit", c_int),
    ("desc", c_char_p),
    ("next", POINTER(cpu_cap))
]

getCPUInfo = _dll.getCPUInfo

ProcInfo = cpu_info.in_dll(_dll, "ProcInfo")
numCaps = c_int.in_dll(_dll, "numCaps")
libShutdown = _dll.lib_shutdown

getCap = _dll.getCap
getCap.restype = cpu_cap
